<?php
declare(strict_types=1);

namespace Inti\Wp\Middleware;

use Doctrine\DBAL\Connection;
use Inti\Wp\Plugin\Service\PluginRunner;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Server\RequestHandlerInterface;
use function add_action;
use function define;
use function dirname;
use function rtrim;

/**
 * Class Bootstrap
 *
 * @package Inti\Wp\Middleware
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-middleware
 */
final class Bootstrap implements MiddlewareInterface
{
    private Connection $conn;
    private PluginRunner $runner;
    private array $config;

    public function __construct(Connection $conn, PluginRunner $runner, array $config)
    {
        $this->conn = $conn;
        $this->runner = $runner;
        $this->config = $config;
    }

    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        /** @noinspection PhpUnusedLocalVariableInspection */
        $table_prefix = 'wp_';

        /** @noinspection PhpInternalEntityUsedInspection */
        $dbParams = $this->conn->getParams();

        define('DB_NAME', $dbParams['dbname']);
        define('DB_USER', $dbParams['user']);
        define('DB_PASSWORD', $dbParams['password']);
        define('DB_HOST', $dbParams['host']);
        define('DB_CHARSET', 'utf8mb4');
        define('DB_COLLATE', 'utf8mb4_croatian_ci');

        define('AUTH_KEY',         'cx=-lrIPB?L(mF{$+&Iof KO&,VAjKqRDH!r`]+3J34fQ=~I4?Ry~~Fz$-UaPz|w');
        define('SECURE_AUTH_KEY',  'RLmo.d=+tixEpuW~7xV]YnY)X5-jf~F?Zy-J3-6A!vgLZ;RD*G)p_dRs`/*ms)U_');
        define('LOGGED_IN_KEY',    '<}e >myM4Nr7Ok3TL Jcl7&h 9l^2_wm~IUq9$[0H;i(*|s[^X%UD Vd+8A+{STJ');
        define('NONCE_KEY',        '$85.Cyhv_R;.M<ye,AzlyzE()SO{Mk.l{k<=%;G<2sh!M+M9;SHP]hT~HtEwNB3X');
        define('AUTH_SALT',        'C%U x*]]lH^Mx7Q OJ=x5G-/s}+F.`Reb3|xxgzlaY.b6``BK#kn!-Th~q6Hp2fA');
        define('SECURE_AUTH_SALT', 'TsoKpcgGGM-g[F-aI;B .5SpYz?+;Ri|=}:HzC9XLdhTi-hlm/^H#>b*kwdH7[vb');
        define('LOGGED_IN_SALT',   '_ucsx?D{Wz)3U){h;*ST7G)je)$=l:XG+|F_O@wz?[+.L701K?s-=Q%]t`mVCS#E');
        define('NONCE_SALT',       'S#e)@S4/|p{-!adaiiON#NltECM})-XqRq!mr-=s0{-e(g| ],i}V}vVV5k9,jE-');

        $uri = $request->getUri();
        define('WP_HOME', rtrim((string) $uri->withQuery('')->withPath('/'), '/'));
        define('WP_SITEURL', WP_HOME . '/wp');
        define('WP_CONTENT_DIR', dirname(ABSPATH));
        define('WP_CONTENT_URL', WP_HOME);

        require_once ABSPATH . 'wp-includes/plugin.php';

        add_action('plugins_loaded', function () {
            $this->runner->run($this->config['plugins'] ?? []);
        });

        foreach ($this->config['globals'] ?? [] as $global) {
            global $$global;
        }

        require_once ABSPATH . 'wp-settings.php';

        return $handler->handle($request);
    }
}
