<?php
declare(strict_types=1);

namespace Inti\Wp\Middleware\Handler\Admin;

use Laminas\Diactoros\Response;
use Laminas\Diactoros\Response\RedirectResponse;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\RequestHandlerInterface;
use function intval;
use function wp_download_language_pack;

/**
 * Class Install
 *
 * @package Inti\Wp\Middleware\Handler\Admin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-middleware
 */
final class Install implements RequestHandlerInterface
{
    public function handle(ServerRequestInterface $request): ResponseInterface
    {
        $step = intval($request->getQueryParams()['step'] ?? null);

        if ($step === 0) {
            require_once ABSPATH . 'wp-admin/includes/file.php';
            require_once ABSPATH . 'wp-admin/includes/translation-install.php';

            wp_download_language_pack('hr');

            return new RedirectResponse(
                $request->getUri()->withQuery('language=hr&step=1')
            );
        }

        return new Response();
    }
}
